package hu.bme.iit.ar.opencvexample;

import android.opengl.GLES10;
import java.nio.FloatBuffer;

public class Mesh extends Resource{
  protected FloatBuffer VB = null;
  protected FloatBuffer TB = null;
  protected FloatBuffer NB = null;
  protected int vertexcount = 0;

  public Mesh(String name){
    super(name);
  }
  public void load(){
    super.load();
  }
  public void destroy(){
    super.destroy();
    this.VB = null;
    this.TB = null;
    this.NB = null;
  }

  public void render(){
    if (this.VB == null) {
      return;
    }
    GLES10.glEnableClientState(GLES10.GL_VERTEX_ARRAY);
    GLES10.glVertexPointer(3, GLES10.GL_FLOAT, 0, this.VB);
    if (this.TB != null) {
      GLES10.glEnableClientState(GLES10.GL_TEXTURE_COORD_ARRAY);
      GLES10.glTexCoordPointer(2, GLES10.GL_FLOAT, 0, this.TB);
    }
    if (this.NB != null) {
      GLES10.glEnableClientState(GLES10.GL_NORMAL_ARRAY);
      GLES10.glNormalPointer(GLES10.GL_FLOAT, 0, this.NB);
    }
    GLES10.glDrawArrays(GLES10.GL_TRIANGLES, 0, this.vertexcount);
    GLES10.glDisableClientState(GLES10.GL_VERTEX_ARRAY);
    GLES10.glDisableClientState(GLES10.GL_TEXTURE_COORD_ARRAY);
    GLES10.glDisableClientState(GLES10.GL_NORMAL_ARRAY);
  }  
}




