package hu.bme.iit.ar.opencvexample;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.opengl.GLES10;
import android.opengl.GLUtils;
import java.io.IOException;

public class Texture extends Resource
{
  protected int[] id = new int[1];
  protected String filename = null;
  protected float repeatU = 1;
  protected float repeatV = 1;

  public Texture(String name) {
    super(name);
    id[0] = -1;
  }
  public int getID() {
    return this.id[0];
  }
  public void setFileName(String filename) { this.filename = filename;
  }
  public void setRepeatU(float v){repeatU = v;}
  public void setRepeatV(float v){repeatV = v;}

  public void load()
  {
    super.load();
    GLES10.glGenTextures(1, this.id, 0);
    Bitmap bitmap;    
    try{
      bitmap = BitmapFactory.decodeStream(Globals.assetManager.open(this.filename == null ? this.name : this.filename));
    }
    catch (IOException e){
      e.printStackTrace();
      return;
    }
    
    GLES10.glBindTexture(GLES10.GL_TEXTURE_2D, this.id[0]);

    GLES10.glTexParameterx(GLES10.GL_TEXTURE_2D, GLES10.GL_TEXTURE_MIN_FILTER, GLES10.GL_NEAREST);
    GLES10.glTexParameterx(GLES10.GL_TEXTURE_2D, GLES10.GL_TEXTURE_MAG_FILTER, GLES10.GL_NEAREST);

    GLUtils.texImage2D(GLES10.GL_TEXTURE_2D, 0, bitmap, 0);

    bitmap.recycle();
  }

  public void destroy() {
    super.destroy();
    GLES10.glDeleteTextures(1, this.id, 0);
  }

  public void enable() {
    GLES10.glEnable(GLES10.GL_TEXTURE_2D);
    GLES10.glBindTexture(GLES10.GL_TEXTURE_2D, this.id[0]);
    GLES10.glMatrixMode(GLES10.GL_TEXTURE);
    GLES10.glLoadIdentity();
    if(repeatU *  repeatV != 1)
    {
        GLES10.glScalef(repeatU, repeatV, 1.0f);
    }
    GLES10.glMatrixMode(GLES10.GL_MODELVIEW);
  }

  public static void disable() {
    GLES10.glBindTexture(GLES10.GL_TEXTURE_2D, 0);
    GLES10.glDisable(GLES10.GL_TEXTURE_2D);
  }
}